<!--
 * @Descripttion: 当前组件信息
 * @version: 1.0.0
 * @Author: 无尘
 * @Date: 2019-08-14 16:51:07
 * @LastEditors  : 无尘
 * @LastEditTime : 2020-02-25 15:08:26
 -->
<!--
<org-tree v-if="item.children.length" :itemData="item.children" ></org-tree>

import orgTree from './org-tree.vue';
-->
<template>
  <ul class="m-l-10">
    <draggable :list="itemData" class="org-component" :options="leftOption" :move="onMove" @start="isDragging = true" @end="itemMoveEnd">
      <li v-for="(item, index) in itemData" :key="index + 'gic'">
        <div class="li-cell cursor-pointer" @click="toggleExpand(item)">
          <span :class="['font-12 color-606266', item.isStore == 1 ? 'color-fff' : '', item.expand ? 'el-icon-caret-bottom' : 'el-icon-caret-right']"></span><span :class="['font-14 p-l-10 p-r-10 iconfont', item.isStore == 1 ? 'icondianpu-kuai' : 'iconqiye-tianchong', item.bindFlag == 1 ? 'color-2f54eb' : 'color-dedfe6']"></span><span class="font-14 color-606266">{{ item.label }}</span>
        </div>
        <li-row v-show="!!item.children.length && item.expand" :itemObj="item" :itemData="item.children"></li-row>
      </li>
    </draggable>
  </ul>
</template>
<script>
import draggable from 'vuedraggable';
import errMsg from '@/common/js/error';
import { getRequest } from '@/api/api';
export default {
  name: 'li-row',
  components: {
    draggable
  },
  props: {
    itemData: {
      type: [Object, Array],
      default() {
        return [];
      }
    },
    itemObj: {
      type: [Object, Array],
      default() {
        return [];
      }
    }
  },
  data() {
    return {
      // leftOption
      leftOption: {
        group: {
          name: 'people',
          pull: true,
          put: false
        },
        sort: false,
        disabled: false
      }
    };
  },
  methods: {
    /**
     * 展开或者关闭下级
     */
    async toggleExpand(item) {
      const that = this;
      // console.log(item);
      item.expand = item.expand ? false : true;
      // 点击的时候，如果非门店且子级是空的需要请求获取子级
      if (item.isStore == 0 && !item.children.length && !item.loaded) {
        item.children = await that.getChildData(item);
      }
    },
    /**
     * 获取下级数据
     */
    getChildData(item) {
      const that = this;
      let para = {
        enterpriseId: item.enterpriseId,
        departmentId: item.departmentId, //
        type: item.type //
      };
      return new Promise((resolve, reject) => {
        if (item.type == 3) {
          resolve([]);
          return false;
        }
        getRequest('/haoban-manage3-web/unbind-department-list', para)
          .then(res => {
            let resData = res.data;
            if (resData.errorCode == 1) {
              // 加一个已加载标志
              if (resData.result.length) {
                item.loaded = true;
                resData.result.forEach(ele => {
                  ele.expand = false;
                  ele.children = [];
                  ele.level = item.level + 1;
                  ele.label = ele.departmentName;
                  ele.enterpriseId = item.enterpriseId;
                });
              }
              resolve(resData.result || []);
              return false;
            }
            resolve([]);
            errMsg.errorMsg(resData);
          })
          .catch(function(error) {
            resolve([]);
            that.$message.error({
              duration: 1000,
              message: error.message
            });
          });
      });
    },
    /**
     *  move{relatedContext, draggedContext}
     */
    onMove(evt) {
      // const that = this;
      // 判断中间是否存在父级
      const draggedElement = evt.draggedContext.element;
      // 首级不能移动
      if (draggedElement.level == 0) {
        return false;
      }
      console.log('gic:move-->', evt, !draggedElement.fixed);
      return !draggedElement.fixed;
    },
    /**
     *  move end
     */
    itemMoveEnd(evt) {
      const that = this;
      // 判断中间是否已经添加
      console.log('gic:', evt, that.itemObj, that.itemData);
      that.$forceUpdate();
    },
    /**
     * 获取子级的数据
     */
    async getNextData() {
      const that = this;
      for (let index = 0; index < that.itemData.length; index++) {
        that.itemData[index].expand = true;
        // 获取子集的时候会加一个加载的标志，来避免移动后重复加载子集
        if (!that.itemData[index].loaded) {
          that.itemData[index].children = await that.getChildData(that.itemData[index]);
        }
      }
    }
  },
  watch: {
    itemData: function(newData, oldData) {
      const that = this;
      if (newData.length) {
        that.getNextData();
      }
    }
  },
  mounted() {
    const that = this;
    if (that.itemData.length) {
      that.getNextData();
    }
  },
  beforeDestroy() {
    this.tempArr = [];
  }
};
</script>
<style lang="less" scoped>
.li-cell {
  line-height: 26px;
  .color-fff {
    color: #fff;
  }
}

.w-110 {
  width: 110px;
}

.w-320 {
  width: 320px;
}

.m-t-14 {
  margin-top: 14px;
}

.child-row {
  padding-left: 10px;
}
</style>
